<?php

use WHMCS\Database\Capsule as DB;
use WHMCS\View\Menu\Item as MenuItem;
use MDreg\domain;
use WHMCS\ClientArea;

$currentUser = new \WHMCS\Authentication\CurrentUser;
if ($currentUser->isAuthenticatedUser()) {
    add_hook('InvoiceCreation', 1, function ($vars) {
        if (WHMCS\Session::getAndDelete("transferMoreThan1")) {

            $invoices = DB::table("tblinvoiceitems")->where('invoiceid', '=', $vars['invoiceid'])->get();
            foreach ($invoices as $invoice) {
                $replacement = preg_replace("/[1-9]+/", WHMCS\Session::get("regperiod"), $invoice->description);
                DB::table("tblinvoiceitems")->where('id', $invoice->id)->update(['description' => $replacement]);
                if ($invoice->relid != 0) {
                    DB::table("tbldomains")->where('id', $invoice->relid)->update(['registrationperiod' => WHMCS\Session::get("regperiod")]);
                }
            }
        }
    });

    add_hook('ClientAreaPrimaryNavbar', 1, function ($primaryNavbar) {
        /** @var \WHMCS\View\Menu\Item $primaryNavbar */
        if (!is_null($primaryNavbar->getChild('Billing'))) {
            $Billing = $primaryNavbar->getChild('Billing');
            // $newMenu = $primaryNavbar->addChild(
            //     'uniqueMenuItemName',
            //     array(
            //         'name' => 'Home',
            //         'label' => Lang::trans('languageStringVariable'),
            //         'uri' => 'clientarea.php',
            //         'order' => 99,
            //         'icon' => 'fas fa-calendar-alt',
            //     )
            // );
            $Billing->addChild('divider', array(
                'order' => '99'
            ))->setClass('nav-divider');

            $Billing->addChild(
                'uniqueSubMenuItemName',
                array(
                    'name' => 'chargeBalance',
                    'label' => Lang::trans('شارژ پنل دامنه'),
                    'uri' => 'index.php?m=Manage_Domain&action=check_balance',
                    'order' => 100,
                    'icon' => 'fas fa-file-invoice-dollar',
                )
            );
        }
    });
}



add_hook('OrderDomainPricingOverride', 1, function ($vars) {
    //TODO validate regperiod
    if (WHMCS\Session::getAndDelete("transferMoreThan1")) {

        $domains = new WHMCS\Domains();
        $domainparts = $domains->splitAndCleanDomainInput($_REQUEST['domain']);

        WHMCS\Session::set("regperiod", $_POST["regperiod"]);

        $setPrice = new MDadd\SetPrice;
        $prices = $setPrice->transferValue($domainparts["tld"]);
        return $prices[$_POST["regperiod"]];
    }
});

add_hook('AdminClientDomainsTabFields', 1, function ($vars) {
    try {
        $query = (new \WHMCS\Domain\Domain)::find($vars['id']);

        if ($query->registrar == 'Manage_Domain') {

            $params = \WHMCS\Module\Registrar::factoryFromDomain($query)->buildParams();

            if (is_null(domain::$details)) {
                $domain = (new domain($params))->getDomainID();
                $response = $domain->getDomainOrderInfo($domain->domainid);
            } else {
                $response = domain::$details;
            }

            $return = ['domainid' => $domain->domainid];
            foreach ($response["details"] as $key => $value) {
                if (is_array($value)) {
                    foreach ($value as $sub_key => $sub_value) {
                        if (is_array($sub_value)) {
                            foreach ($sub_value as $last_key => $last_value) {
                                $return[$key . ' ' . $sub_key . ' ' . $last_key] = $last_value;
                            }
                        } else {
                            $return[$key . ' ' . $sub_key] = $sub_value;
                        }
                    }
                } else {
                    $return[$key] = $value;
                }
            }

            return $return;
        }
    } catch (\Throwable $th) {
        //throw $th;.
        return;
    }
});
