<?php
require_once __DIR__ . '/vendor/autoload.php';
require_once __DIR__ . '/Manage_Domain.php';

use WHMCS\Config\Setting;
use MDadd\NicHandle;
use WHMCS\Database\Capsule as DB;
use MDreg\domain;

if (!defined("DS")) {
    define('DS', DIRECTORY_SEPARATOR);
}


add_hook('ClientAreaFooterOutput', 1, 'MD_removePrivateNS');

add_hook('ClientAreaPage', 1, 'MD_getPricateNS');

add_hook('ClientAreaFooterOutput', 1, 'MD_showPrivateNS');

add_hook('ShoppingCartValidateDomainsConfig', 1, 'MD_checkNic');

function MD_checkNic($vars)
{
    $domains = $_SESSION["cart"]["domains"];

    foreach ($domains as $key => $domainname) {

        $domainfield = $_SESSION["cart"]["domains"][$key]["fields"];

        $domainparts = explode(".", $domainname["domain"], 2);
        $additflds = new WHMCS\Domains\AdditionalFields();

        $additflds->setTLD($domainparts[1]);

        if (isset($additflds->getFields()[0]) && $additflds->getFields()[0]['Name'] == 'nichandle') {
            $nichandle = new NicHandle($domainfield[0]);
            if (!$nichandle->existsAndValid()) {

                $check = NicHandle::checkValid($domainfield[0]);

                if ($check['status'] == 'error') {
                    return [$check['message']];
                }

                NicHandle::updateValid($domainfield[0]);
            }

            if ($domainname['type'] == 'transfer') {
                $check_domain = NicHandle::checkDomain($domainname["domain"]);
                if ($check_domain['status'] == 'error') {
                    return [$check_domain['message']];
                }
            }
        }
    }
}

function MD_removePrivateNS($vars)
{

    if ($_GET["action"] == "domainregisterns" && isset($_REQUEST['domainid']) && is_numeric($_REQUEST['domainid'])) {
        if (DB::table('tbldomains')->where('id', $vars['domainid'])->where('registrar', 'Manage_Domain')->first()) {

            return <<<HTML
            <script >
                     $(document).ready(function(){
                    // $("#Primary_Sidebar-Domain_Details_Management-Manage_Private_Nameservers").remove();
                    $(".form-horizontal").addClass('hidden');
                });
            </script>
            HTML;
        }
    }
    return <<<HTML
            <script >
                     $(document).ready(function(){
                    // $("#Primary_Sidebar-Domain_Details_Management-Manage_Private_Nameservers").remove();
                });
            </script>
    HTML;
}

function MD_getPricateNS($vars)
{
    if ($_GET["action"] == "domainregisterns" && isset($_REQUEST['domainid']) && is_numeric($_REQUEST['domainid'])) {
        if (DB::table(domain::domains_tbl)->where('id', $vars['domainid'])->where('registrar', 'Manage_Domain')->first()) {
            $nameservers = Manage_Domain_private_nameserver_database()->where('domain_id', $vars['domainid'])->get();
            $vars['modulePath'] = __dir__;
            $vars['baseUrl'] = WHMCS\Utility\Environment\WebHelper::getBaseUrl();
            $vars['nameServers'] = array(
                'msg' => 'hdfl',
                'list' => is_8() ? $nameservers->toArray() : $nameservers,
            );
            return $vars;
        }
    }
}

function MD_showPrivateNS($vars)
{
    if ($_GET["action"] == "domainregisterns" && isset($_REQUEST['domainid']) && is_numeric($_REQUEST['domainid'])) {

        $domain = DB::table('tbldomains')->where('id', $vars['domainid'])->first();

        if ($domain->registrar != "Manage_Domain") {
            return;
        }

        $params = WHMCS\Module\Registrar::factoryFromDomain((new \WHMCS\Domain\Domain)::find($vars['domainid']))->buildParams();

        if ($_REQUEST['subaction'] == 'sync') {
            Manage_Domain_private_nameserver_Manage($params);
        }

        $private_name_servers = Manage_Domain_private_nameserver_database()->where('domain_id', $vars['domainid'])->get();
        $smarty = new \WHMCS\Smarty;

        $smarty->assign('nameServers', $private_name_servers);
        $smarty->assign('domain_id_whmcs', $vars['domainid']);
        $view = $smarty->fetch(ROOTDIR . '/modules/registrars/Manage_Domain/templates/PrivateNameServerTable.tpl');

        return <<<HTML
            <script >
                     $(document).ready(function(){
                    $(".primary-content").append(`$view`);
                });
                function syncpns(domainid)
                {
                            jQuery.ajax({
                    type: "GET",
                    url: "clientarea.php?action=domainregisterns&subaction=sync&domainid=" + domainid,
                    data: {
                        token: jQuery("input[name=token]").val(),
                    },
                    success: function(data) {
                        location.reload();
                    },
                    error: function() {
                        jQuery("#loading").addClass("hidden");
                    },
                    });
                }
            </script>
HTML;
    }
}
