<?php

namespace MDadd;

use Exception;
use MDreg\api;
use MDreg\traits\checker;
use WHMCS\Database\Capsule as DB;
use WHMCS\User\Client;


class Balance extends Client
{
    const apiInvoiceType = 3;
    protected $client;
    protected $paramsList;
    protected $apiUser;

    public function __construct()
    {
        $this->client = self::GetClientsDetails($_SESSION["uid"]);
        checker::getParams();
        $this->paramsList = checker::$paramsList;

        $this->apiUser = $this->getAPIuser();
    }

    public static function GetClientsDetails($id)
    {
        $command = 'GetClientsDetails';
        $postData = array(
            'clientid' => $id,
            'stats' => true,
        );
        $results = localAPI($command, $postData);
        return $results;
    }

    public function ChargeAccount($params, $subUserId)
    {
        $api = new api($this->paramsList);
        if (!is_array($params)) {
            throw new Exception('params must be array');
        }

        $result = $api->post()->params(['amount' => $params['amount'], 'note' => $params['note']])->makeUrl('addBalance', '/' . $subUserId)->exe();

        if ($result["result"] == "success") {
            header('Location: index.php?m=Manage_Domain&Status=success');
            die;
        }
        return $result;
    }

    public function applycredit($amount, $original_amount, $subUserId)
    {
        $command = 'CreateInvoice';
        $postData = array(
            'userid' => $_SESSION["uid"],
            'itemdescription1' => 'invoice for charge domain account',
            'itemamount1' => $amount,
            'autoapplycredit' => 0,
            'duedate' => date('Y-m-d'),
        );
        try {
            $localAPIresults = localAPI($command, $postData);
            if ($localAPIresults["result"] != "success") {
                throw new Exception(json_encode($localAPIresults));
            }

            DB::table("tblinvoiceitems")->where('invoiceid', $localAPIresults["invoiceid"])->update(['type' => 'Manage_Domain']);
            $params = [
                'id' => $this->apiUser["user_id"],
                'note' => 'Charge with API,Invoice ID is: ' . $localAPIresults["invoiceid"],
                'amount' => $original_amount,
            ];
            $foreignAPIresponce = $this->ChargeAccount($params, $subUserId);
            if ($foreignAPIresponce['success'] != true) {
                call_user_func_array('localAPI', ['UpdateInvoice', [
                    'invoiceid' => $localAPIresults["invoiceid"],
                    'notes' => $foreignAPIresponce['result']['msg'],
                    'status' => 'Cancelled',
                ]]);
                throw new Exception($foreignAPIresponce['result']['msg']);
            }
            call_user_func_array('localAPI', ['ApplyCredit', [
                'invoiceid' => $localAPIresults["invoiceid"],
                'amount' => 'full',
            ]]);

            return 'success';
        } catch (Exception $e) {
            return $e->getMessage();
        }
        return $localAPIresults;
    }
    // public static function isVAlid()
    // {
    //     $result = self::getAPIuser();

    //     if ($result) {
    //         return true;

    //     }
    //     return false;

    // }

    public static function getAPIuser()
    {
        $client = self::GetClientsDetails($_SESSION["uid"]);

        checker::getparams();
        $api = new api(checker::$paramsList);
        $result = $api->get()->makeUrl('getSubUser', '', '', ['search' => $client['email']])->exe();

        if ($result['success'] == true) {
            return $result['result'];
        }
        return false;
    }

    public static function getBalance()
    {

        $client = self::GetClientsDetails($_SESSION["uid"]);
        checker::getParams(); //todo handle error
        $api = new api(checker::$paramsList);
        $user_id = $api->get()->makeUrl('getSubUser', '', '', ['search' => $client])->exe();
        $result = $api->get()->makeUrl('getBalance', '/' . $client["email"])->exe();
        if ($result['success'] == true) {
            return $result['result'];
        }
        return false;
    }

    public function addBalance($amount, $subUserId)
    {
        // MD_dd($this->client["credit"]);
        if (!is_numeric($amount)) {
            throw new Exception('Input amount should be integer');
        }
        $credit = $this->client["credit"];
        $currency = new Currency;

        $original_amount = $amount;
        $amount = $currency->forInvoice($amount);

        if ($credit < $amount) {
            throw new Exception('Your WHMCS credit is not enough, *Please charge your credit');
        }

        // $api = DB::table("tblregistrars")->where('registrar', 'Manage_Domain')->pluck('value', 'setting');
        // $configs = DB::table("mod_MD_configs")->pluck('value', 'key');

        // $currency->forInvoice($amount);

        $result = $this->applycredit($amount, $original_amount, $subUserId);
        if ($result == 'success') {
            return ['success' => true, 'amount' => $amount];
        }
        return ['success' => false, 'msg' => $result];;
    }

    public static function getCredit()
    {
        $client = self::GetClientsDetails($_SESSION["uid"]);
        return $client["credit"];
    }
}
