<?php

namespace MDadd;

use Exception;
use MDadd\FastImporter;
use WHMCS\Database\Capsule as DB;
use WHMCS\Session;
use WHMCS\User\Client;

class Currency extends Client
{
    protected $defaultCurrency;
    protected $localCurrency;
    protected $apiCurrency;
    protected $exchange;

    public function __construct()
    {
        $configs = DB::table("mod_MD_configs")->pluck('value', 'key');
        if (is_8()) {
            $configs = $configs->toArray();
        }
        $this->apiCurrency = DB::table("tblcurrencies")->where('id', $configs['currency'])->first();

        $this->exchange = $configs['chargeEx'];
        if ($this->exchange == 0) {
            throw new Exception('exchange can\'t be zero! *please add an exchange rate in Manage Domain settings');
        }

        $this->defaultCurrency = DB::table("tblcurrencies")->where('default', 1)->first();

        $this->localCurrency = getCurrency(Session::get("uid"), Session::get("currency"));
    }

    public function forUser($amount)
    {
        $first = $this->apiCurrency->id;
        $second = $this->localCurrency['id'];
        $rate = FastImporter::getCurrencyRate($first, $second);

        return $this->localCurrency['perfix'] . round((string) ($amount * $rate) / $this->exchange) . ' ' . $this->localCurrency['suffix'];
    }

    public function forInvoice($amount)
    {

        $second = $this->apiCurrency->id;
        $first = $this->localCurrency['id'];
        $rate = FastImporter::getCurrencyRate($first, $second);

        return ($amount * $rate) * $this->exchange;
    }

}
