<?php

namespace MDadd;

use Laminas\Validator\File\Md5;
use MDadd\TBL\getData;
use MDreg\domain;
use MDreg\traits\checker;
use Exception;
use WHMCS\Database\Capsule as DB;
use whmcs\Carbon;

class FastImporter extends OutPutUi
{
    private static $Currencies = [];
    public $vars;
    public $get;
    public $post;
    private static $configs;
    public $applyPromotion;

    public function __construct()
    {

        checker::getParams();
        self::getCurrency();
        $this->smarty = $this->smarty();
        $this->params = checker::$paramsList;
        $this->get = $_GET;
        $this->post = $_POST;
        $this->getConfig();
    }

    public function outPut()
    {
        if ($this->get['getTlds'] == 1) {
            $this->tldsPrice();
        }
        if (count($_POST) > 0) {

            $this->saveFastimporter();
        }

        if (count(self::$configs) != 0) {
            $tldsList = $this->getTldsPrice();
            $this->smarty->assign('hasAnyConfig', self::$configs);
            $this->smarty->assign('tldsChecked', $this->getCheckedTldsList());
            $this->smarty->assign('tldsList', $tldsList);
            $this->smarty->assign('tldsCount', count($tldsList));
            $this->smarty->assign('actions', ['register', 'renew', 'transfer']);
            $this->smarty->assign('this', $this);
        }
        $this->tempName = "FastImporter copy.tpl";
        $this->renderTemplte();
    }

    function getCheckedTldsList()
    {
        $TldPricing = DB::table(domain::domainPricing_tbl)->pluck('extension', 'extension');
        if (is_8()) {
            $TldPricing = $TldPricing->toArray();
        }
        return $TldPricing;
    }

    function getConfig()
    {
        self::$configs = DB::table(domain::modConfig_tbl)->pluck('value', 'key');
        if (is_8()) {
            self::$configs = self::$configs->toArray();
        }
        return self::$configs;
    }


    static function getCurrencyRate($firstId, $secondId)
    {
        if ($firstId == $secondId) {
            return 1;
        }
        $mainCurrency = DB::table(domain::currencies_tbl)->where('default', '1')->first();
        $Currencies = self::$Currencies;
        if ($mainCurrency->id == $firstId) {
            return $Currencies[$secondId]->rate;
        } elseif ($secondId == $mainCurrency->id) {
            return 1 / $Currencies[$firstId]->rate;
        } else {
            return (1 / $Currencies[$firstId]->rate) * $Currencies[$secondId]->rate;
        }
    }

    static function getCurrency()
    {
        if (count(self::$Currencies) == 0) {
            $currencies = DB::table("tblcurrencies")->get();
            if (is_8()) {
                $currencies = $currencies->keyBy('id')->toArray();
            } else {
                $currencies = collect($currencies)->keyBy('id')->toArray();
            }
            self::$Currencies = $currencies;
        }
        return self::$Currencies;
    }

    function tldsPrice()
    {
        try {
            ob_clean();
            $this->getTldsPrice();
            http_response_code(200);
            die(json_encode(["msg" => "get list of domain please don't close page to check you'r request"]));
        } catch (Exception $ex) {
            http_response_code(400);
            die(json_encode(["msg" => "please try again we have problem to get price"]));
        }
    }

    function getTldsPrice()
    {
        $tblTempPrice = DB::table(domain::tempPrice_tbl);
        $last1h = Carbon::now()->subHour()->format('Y-m-d H:i:s');
        $now = Carbon::now()->format('Y-m-d H:i:s');
        if (!$tblTempPrice->whereBetween('created_at', [$last1h, $now])->exists()) {
            $tldsPrice = $this->getTldPriceFromApi();
            $tlds = [];
            $tblTempPrice->truncate();

            foreach ($tldsPrice as $name => $value) {
                $tlds[] = ['tld' => $name, 'price' => serialize($value)];
            }

            DB::table("mod_md_temp_price")->insert($tlds);
        } else {
            $tlds = $tblTempPrice->pluck('price', 'tld');
            foreach ($tlds as $key => $value) {
                $tldsPrice[$key] = unserialize($value);
            }
        }
        return $tldsPrice;
    }

    function getTldPriceFromApi()
    {
        $special = isset($this->get['special']) ? '/' . $this->get['special'] : '';
        $domain = new domain($this->params);
        $domain->api->get()->makeUrl('tlds', $special)->exe();
        if (!$domain->api->response['success']) {
            throw new Exception($domain->api->response['msg']);
        }
        return $domain->api->response['result'];
    }

    function saveFastimporter()
    {
        ob_clean();
        try {
            $config = $this->getConfig();
            $groups = array();
            $forceGroup = array();
            $forceCurrency = array();
            $exchange = "";
            $currencyF = "";
            $rategroup0 = "";
            foreach ($config as $key => $data) {
                if (strpos($key, 'group') !== false) {
                    if (strpos($key, 'group_0') !== false) {
                        $rategroup0 = $data == null ? 1 : $data / 100;
                    }
                    $groupid = substr_replace($key, '', 0, 6);
                    if ($data == null && $groupid != 0) {
                        continue;
                    }
                    $groupRate = $data == null ? 1 : $data / 100;
                    $groups[$groupid] = $groupRate;
                }
                if (strpos($key, 'forceGroup') !== false) {
                    $forceGroupid = $data;
                    if ($config['group_' . $forceGroupid] == null && $forceGroupid != 0) {
                        continue;
                    }
                    $forceGroup[] = $forceGroupid;
                }
                if (strpos($key, 'forceCurrency') !== false) {
                    $forceCurrencyid = $data;
                    $forceCurrency[] = $forceCurrencyid;
                }
                if (strpos($key, 'exchange') !== false) {
                    $exchange = ($data == null) ? 1 : $data;
                }
                if (strpos($key, 'currency') !== false) {
                    $currencyF = $data;
                }
                if ($key == 'registrar') {
                    $default_registrar = empty($data) ? 'atak' : $data;
                }
            }
            $this->getCurrency();
            $tlds = DB::table(domain::tempPrice_tbl)->where('tld', $this->post['tld'])->first();
            $unserialize_prices = unserialize($tlds->price);
            if (isset($unserialize_prices['nic'])) {
                $priceApi = $unserialize_prices['nic']['base'];
            } else {
                $priceApi = $unserialize_prices[$default_registrar]['base'];
            }
            DB::table(domain::domainPricing_tbl)->updateorInsert(
                ["extension" => "." . $this->post['tld']],
                [
                    "redemption_grace_period_fee" => $priceApi[0]["restore"],
                    'grace_period' => '20',
                    'redemption_grace_period' => '20',
                    'grace_period_fee' => '0',
                    'autoreg' => 'Manage_Domain'
                ]
            );
            $tldID = (DB::table(domain::domainPricing_tbl)->where("extension", "." . $this->post['tld'])->first())->id;
            foreach (self::$Currencies as $currency) {
                $resultCurrency = $this->getCurrencyRate($currencyF, $currency->id);
                if ($currency->default == 1) {
                    DB::table(domain::domainPricing_tbl)->where("extension", "." . $this->post['tld'])->update(
                        [
                            "redemption_grace_period_fee" => $priceApi[0]["restore"] * $resultCurrency * $exchange * $rategroup0,
                            'grace_period' => '0',
                            'redemption_grace_period' => '0',
                            'grace_period_fee' => '0',
                            'autoreg' => 'Manage_Domain'
                        ]
                    );
                }
            }
            $types = ['domaintransfer' => 'transfer', 'domainregister' => 'register', 'domainrenew' => 'renew'];
            foreach ($types as $type => $index) {
                $this->countPrice($tldID, $priceApi, $type, $index, $exchange, $groups, $currencyF, $forceGroup, $forceCurrency);
            }

            http_response_code(200);
            $data = ["msg" => $this->post['tld'] . " import or update Price"];
        } catch (Exception $ex) {
            http_response_code(400);
            $data = ["error" => $this->post['tld'] . " don't  import Price"];
        }
        die(json_encode($data));
    }

    function countPrice($tldId, $priceApi, $type, $indexType, $exchange, $groups, $currencyF, array $forceGroup, array $forceCurrency)
    {
        // MD_dd($tldId, $priceApi, $type, $indexType, $exchange, $groups, $currencyF,  $forceGroup,  $forceCurrency);
        $tblPricing = DB::table(domain::pricing_tbl);
        foreach ($groups as $index => $group) {
            // TODO if index == 0 check and insert in price change
            foreach (self::$Currencies as $curren) {
                $resultCurrency = $this->getCurrencyRate($currencyF, $curren->id);

                if (in_array($index, $forceGroup) && in_array($curren->id, $forceCurrency)) {
                    $tblPricing->updateorInsert(
                        [
                            'relid' => $tldId,
                            'type' => $type,
                            'currency' => $curren->id,
                            'tsetupfee' => $index,
                        ],
                        [
                            'msetupfee' => !isset($priceApi[$indexType]['1']) ? '-1' : self::calculatePrice(($priceApi[$indexType]['1'] * $exchange   * $resultCurrency), $group),
                            'qsetupfee' => !isset($priceApi[$indexType]['2']) ? '-1' : self::calculatePrice(($priceApi[$indexType]['2'] * $exchange   * $resultCurrency), $group),
                            'ssetupfee' => !isset($priceApi[$indexType]['3']) ? '-1' : self::calculatePrice(($priceApi[$indexType]['3'] * $exchange   * $resultCurrency), $group),
                            'asetupfee' => !isset($priceApi[$indexType]['4']) ? '-1' : self::calculatePrice(($priceApi[$indexType]['4'] * $exchange   * $resultCurrency), $group),
                            'bsetupfee' => !isset($priceApi[$indexType]['5']) ? '-1' : self::calculatePrice(($priceApi[$indexType]['5'] * $exchange   * $resultCurrency), $group),
                            'monthly' => !isset($priceApi[$indexType]['6']) ? '-1' : self::calculatePrice(($priceApi[$indexType]['6'] * $exchange   * $resultCurrency), $group),
                            'quarterly' => !isset($priceApi[$indexType]['7']) ? '-1' : self::calculatePrice(($priceApi[$indexType]['7'] * $exchange   * $resultCurrency), $group),
                            'semiannually' => !isset($priceApi[$indexType]['8']) ? '-1' : self::calculatePrice(($priceApi[$indexType]['8'] * $exchange   * $resultCurrency), $group),
                            'annually' => !isset($priceApi[$indexType]['9']) ? '-1' : self::calculatePrice(($priceApi[$indexType]['9'] * $exchange   * $resultCurrency), $group),
                            'biennially' => !isset($priceApi[$indexType]['10']) ? '-1' : self::calculatePrice(($priceApi[$indexType]['10'] * $exchange   * $resultCurrency), $group),
                        ]
                    );
                } else {
                    if (!$tblPricing->where('relid', $tldId)->where('type', 'domainregister')->where('currency', $curren->id)->where('tsetupfee', $index)
                        ->where('msetupfee', -1)->where('qsetupfee', -1)->where('ssetupfee', -1)->where('asetupfee', -1)->where('bsetupfee', -1)
                        ->where('monthly', -1)->where('quarterly', -1)->where('semiannually', -1)->where('annually', -1)->where('biennially', -1)->exists()) {
                        // if($index ==4 &&  $curren->id !=2)
                        // MD_dd($pricing->where('relid', $tldId)->where('type', 'domainregister')->where('currency', $curren->id)->where('tsetupfee', $index)->exists());
                        if (!$tblPricing->where('relid', $tldId)->where('type', 'domainregister')->where('currency', $curren->id)->where('tsetupfee', $index)->exists()) {
                            $tblPricing->updateorInsert(
                                [
                                    'relid' => $tldId,
                                    'type' => $type,
                                    'currency' => $curren->id,
                                    'tsetupfee' => $index,
                                ],
                                [
                                    'msetupfee' => -1,
                                    'qsetupfee' => -1,
                                    'ssetupfee' => -1,
                                    'asetupfee' => -1,
                                    'bsetupfee' => -1,
                                    'monthly' => -1,
                                    'quarterly' => -1,
                                    'semiannually' => -1,
                                    'annually' => -1,
                                    'biennially' => -1,
                                ]
                            );
                        } else {
                            $tblPricing->where('relid', $tldId)
                                ->where('type', $type)
                                ->where('currency', $curren->id)
                                ->where('tsetupfee', $index)
                                ->update([
                                    'msetupfee' => !isset($priceApi[$indexType]['1']) ? '-1' : self::calculatePrice(($priceApi[$indexType]['1'] * $exchange   * $resultCurrency), $group),
                                    'qsetupfee' => !isset($priceApi[$indexType]['2']) ? '-1' : self::calculatePrice(($priceApi[$indexType]['2'] * $exchange   * $resultCurrency), $group),
                                    'ssetupfee' => !isset($priceApi[$indexType]['3']) ? '-1' : self::calculatePrice(($priceApi[$indexType]['3'] * $exchange   * $resultCurrency), $group),
                                    'asetupfee' => !isset($priceApi[$indexType]['4']) ? '-1' : self::calculatePrice(($priceApi[$indexType]['4'] * $exchange   * $resultCurrency), $group),
                                    'bsetupfee' => !isset($priceApi[$indexType]['5']) ? '-1' : self::calculatePrice(($priceApi[$indexType]['5'] * $exchange   * $resultCurrency), $group),
                                    'monthly' => !isset($priceApi[$indexType]['6']) ? '-1' : self::calculatePrice(($priceApi[$indexType]['6'] * $exchange   * $resultCurrency), $group),
                                    'quarterly' => !isset($priceApi[$indexType]['7']) ? '-1' : self::calculatePrice(($priceApi[$indexType]['7'] * $exchange   * $resultCurrency), $group),
                                    'semiannually' => !isset($priceApi[$indexType]['8']) ? '-1' : self::calculatePrice(($priceApi[$indexType]['8'] * $exchange   * $resultCurrency), $group),
                                    'annually' => !isset($priceApi[$indexType]['9']) ? '-1' : self::calculatePrice(($priceApi[$indexType]['9'] * $exchange   * $resultCurrency), $group),
                                    'biennially' => !isset($priceApi[$indexType]['10']) ? '-1' : self::calculatePrice(($priceApi[$indexType]['10'] * $exchange   * $resultCurrency), $group),
                                ]);
                        }
                    }
                }
            }
        }
    }

    public  function sitePrice($price)
    {
        if (self::$configs['exchange'] == null || self::$configs['exchange'] == "" || self::$configs['exchange'] == 0) {
            return $price;
        }
        $currency = self::$Currencies[self::$configs['currency']];



        $price =  (float) $price * self::$configs['exchange'];




        switch ($currency->format) {

            case 1:
                $price = number_format($price, 2, '.');
                break;
            case 2:
                $price = number_format($price, 2, '.', ',');
                break;
            case 3:
                $price = number_format($price, 2, '.', '.');
                break;
            case 4:
                $price = number_format($price, 0, ',', ',');
                break;
        }

        return   $price;
    }

    public static function calculatePrice($price, $profit)
    {
        $currency = self::$Currencies[self::$configs['currency']];
        $price +=  $price * $profit;
        if ($currency->format == 4)
            return round($price);


        return $price;
    }

    public function currency()
    {
        foreach (self::$Currencies as $currency) {
            if ($currency->code == self::$configs['currency']) {
                return  $currency->code;
            }
        }
    }
}
