<?php

namespace MDadd;

use WHMCS\Database\Capsule as DB;
use WHMCS\Session;

class Register
{
    static $tld;
    static $sld;
    static $clientid;

    public function __construct($tld, $sld)
    {
        self::$clientid = Session::get("uid");
        self::$tld = $tld;
        self::$sld = $sld;
        
    }

    public function addRegisterOrder($data)
    {
        $postData = self::createPostData('register', $data);

        return $this->addOrder($postData);
    }

    public function addTranferOrder($data)
    {
        $postData = self::createPostData('transfer', $data);

        return $this->addOrder($postData);
    }

    public function addOrder($postData)
    {
        $command = 'AddOrder';
        // $postData = self::createPostData('transfer', $data);
        if (self::needsCustomFields(self::$tld)) {
            $postData['customfields'] = $data['customfields'];
        }

        $results = localAPI($command, $postData);

        if ($results['result'] == 'success') {
            return $results;
        }
        return $results['message'];
    }

    public static function needsCustomFields(string $tld)
    {
        include 'resources/domains/dist.additionalfields.php';
        include 'resources/domains/additionalfields.php';
        return $additionaldomainfields[$tld] ?? false;

        // if ($additionaldomainfields[$tld]) {
        //     return $additionaldomainfields[$tld];
        // }
        // return false;
    }
    public static function createPostData($action, $data)
    {
        $payment = self::getPaymentMethod(self::$clientid);

        $notImportant = ['year', 'domain', 'ns2', 'ns1', 'action', 'token', 'eppCode'];
        $domainfields = [];

        foreach ($data as $key => $value) {
            if (in_array($key, $notImportant)) {
                continue;
            }
            $domainfields[$key] = $value;
        }

        $postData = array(
            'clientid' => self::$clientid,
            'domain' => $data['domain'],
            'domaintype' => $action,
            // 'idnlanguage' => array(''),
            'domainfields' => base64_encode(serialize($domainfields)),
            'regperiod' => $data['year'],
            // 'dnsmanagement' => array(0 => false),
            'nameserver1' => $data['ns1'],
            'nameserver2' => $data['ns2'],
            'paymentmethod' => $payment['module'],
        );
        if ($action === 'transfer') {
            $postData['eppcode'] = $data['eppCode'];
        }
        return $postData;
    }

    public static function getPaymentMethod($id)
    {
        $command = 'GetPaymentMethods';
        $postData = array();

        $results = localAPI($command, $postData);
        if ($results['result'] === 'success') {
            return $results['paymentmethods']['paymentmethod'][0];
        }
        //TODO return error message
    }
    public static function isAlreadypending($domain)
    {
        $exists = DB::table('tbldomains')->where([['domain', '=', $domain], ['status', '=', 'Pending'], ['status', '=', 'Active'],
            ['status', '=', 'Pending Transfer'], ['status', '=', 'Pending Registeration']])->exists();
        return $exists;
    }
}
