<?php

namespace MDadd;

use WHMCS\Authentication\CurrentUser;
use WHMCS\Config\Setting;
use WHMCS\Database\Capsule;
use WHMCS\Domains\Extension;
use WHMCS\Session;
use WHMCS\User\Client;

class SetPrice extends Client
{
    const defaultcurrency = ['id' => 1];
    const defaultclientGroup = 0.00;

    protected $tld;
    static $clientId;
    protected $currency = self::defaultcurrency;
    protected $clientGroup = self::defaultclientGroup;

    public function __construct()
    {
        if (!function_exists("getTLDPriceList")) {
            require ROOTDIR . DIRECTORY_SEPARATOR . "includes" . DIRECTORY_SEPARATOR . "domainfunctions.php";
        }
        if (self::isLogin()) {
            $this->currency = getCurrency(Session::get("uid"), Session::get("currency"));
            $this->checkClientGroup();
        }
    }
    public function TransferPrice($tld)
    {
        $this->tld = $tld;
        try {
            $extensionData = Extension::where("extension", $tld)->firstOrFail(array("id"));
            $id = $extensionData->id;

        } catch (Exception $e) {
            return 'array()';
        }
        return Capsule::table("tblpricing")->where([["type", '=', "domaintransfer"], ["currency", '=', $this->currency['id']], ["relid", '=', $id], ['tsetupfee', '=', $this->clientGroup]])->orderBy("tsetupfee", "desc");
    }
    public function checkClientGroup()
    {

        $group = Capsule::table('tblclients')->where('id', self::$clientId)->first('groupid');
        $this->clientGroup = (string) $group->groupid . '.00';

        // $client = new Client;
        // MD_dd($this->users());
        // return $this->getGroupNameAttribute();
    }
    public function checkSession()
    {
        return self::$clientId = $_SESSION["uid"];
    }
    public static function getTldList()
    {
        include_once 'includes/domainfunctions.php';
        // if (self::isLogin()) {
        //     return Capsule::table('tbldomainpricing')->pluck('extension')->toArray();
        // }
        return getTLDList();
        // $pricing = getTLDPriceList('.com', true);
    }
    public static function isLogin()
    {
        if ((new CurrentUser())->isAuthenticatedUser()) {
            self::$clientId = $_SESSION["uid"];
            return true;
        }
        return false;
    }

    public function transferString($tld)
    {
        $prices = $this->TransferPrice($tld);
        $prices = $prices->select('msetupfee', 'qsetupfee', 'ssetupfee', 'asetupfee', 'bsetupfee', 'monthly', 'quarterly', 'semiannually', 'annually', 'biennially')->get();
        if (is_8()) {
            $prices = $prices->toArray();
        }
        
        $result = [];
        $ittrate = 1;
        foreach ($prices[0] as $year => $price) {
            $result[$ittrate] = $this->currency['prefix'] . $price . $this->currency['suffix'];
            $ittrate++;
        }
        return $result;
    }
    public function transferValue($tld)
    {
        $prices = $this->TransferPrice($tld);
        $prices = $prices->select('msetupfee', 'qsetupfee', 'ssetupfee', 'asetupfee', 'bsetupfee', 'monthly', 'quarterly', 'semiannually', 'annually', 'biennially')->get();
        if (is_8()) {
            $prices = $prices->toArray();
        }

        $result = [];
        $ittrate = 1;
        foreach ($prices[0] as $year => $price) {
            if ($price != '-1.00' && $price != '0.00') {
                $result[$ittrate] = $price;
            }
            $ittrate++;
        }

        return $result;
    }
    //TODO unset prices

    public static function suggestTld()
    {
        $spotlight = array_intersect(explode(",", Setting::getValue("SpotlightTLDs")), self::getTldList());
        $result['spotlight'] = $spotlight;
        $test = self::getTldList();
        // MD_dd($result['spotlight'], explode(",", Setting::getValue("SpotlightTLDs")), self::getTldList());
        // $groups =  array_intersect (Capsule::table("tbldomainpricing")->where([["group", '!=', ''],["group", '!=', 'none']])->get()->groupBy("group")->toArray(), self::getTldList());
        $groups = capsule::table("tbldomainpricing")->where([["group", '!=', ''], ["group", '!=', 'none']])->get()
            ->filter(function ($data, $index) use ($test) {
                // MD_dd($data);
                return in_array($data->extension, $test);
            })->groupBy("group")->toArray();
        $result['groups'] = $groups;

        if (!$result['spotlight'] && !$result['groups']) {
            $result['nonetld'] = Capsule::table("tbldomainpricing")->where("group", '')->orwhere("group", 'none')->orderBy("order")->get()
                ->filter(function ($data, $index) use ($test) {
                    // MD_dd($data);
                    return in_array($data->extension, $test);
                })->groupBy("extension")->toArray();
        }
        return $result;
    }
}
