<?php
//65|swKm4jmoEnseTBrX7QHmMHcWSJzYx157zZY1Nnd226fe9a2a
namespace MDreg;

use Exception;
use MDreg\apiResponse;
use MDreg\traits\checker;

use function GuzzleHttp\Psr7\build_query;

class api
{
    use checker;

    public $response;
    public $apiResponseWithoutParse;
    public $sub;
    private $testMode;
    public $apiKey;
    private $apiUrl;
    private $apiPrefix;
    private $actionUrl;
    public $finalUrl;
    public $statusCode;
    private $method;
    private $fields;
    private $curl;
    private $option = [];


    public function __construct($params)
    {
        $this->sub =  $params['sld'];
        $this->testMode = ''; // todo have to be complete
        $this->method = null;
        $this->fields = [];
        $this->apiKey = $params['ApiKey'];
        $this->apiPrefix = '';
        $this->finalUrl = null;
        $this->apiUrl = 'yek.domains/api/v3';
        $this->actionUrl = [
            'register' => '/domain/register', //*checked
            'transfer' => '/domain/transfer', //*checked
            'renew' => '/order/domain/{domain_id}/renew',
            'checkAvailable' => '/domain/check', //*checked
            'saveNameServer' => '/domain/NameServer',
            // 'saveContacts' => '/order/domain/changeContact',
            'changeLock' => '/domain/ChangeLock',
            'sync' => '/order/domain', //*checked
            'getEPPCode' => '/domain/eppCode',
            'IDProtectToggle' => '/domain/privacy',
            'childNameServer' => '/domain/ChildNameServer',
            'syncPrivateNS' => '/domain/ChildNameServer/sync',
            'tlds' => '/domain/prices',
            'transaction' => '/financial/transactions/list', //* working
            'validateUser' => '/client/validateUser',
            'getBalance' => '/client/getBalance',
            'addBalance' => '/management/client/changeBalance',
            'getByDomainName' => '/order/domain/getID', //*checked
            'createContact' => '/domain/contact', //*checked
            'getDomainOrderInfo' => '/order/domain', //*checked
            'getSubUser' => '/management/client/list', //*checked
        ];
    }

    public function post()
    {
        $this->method = 'POST';
        return $this;
    }

    public function get()
    {
        $this->method = 'GET';
        return $this;
    }

    public function put()
    {
        $this->method = 'PUT';
        return $this;
    }

    public function delete()
    {
        $this->method = 'DELETE';
        return $this;
    }

    public function params($fields)
    {
        $this->fields = $fields;
        return $this;
    }

    public function getParams()
    {
        return isset($this->fields) ? $this->fields : [];
    }

    function exe()
    {
        if (!isset($this->finalUrl)) {
            $this->makeUrl();
        }
        $this->curl = curl_init();
        curl_setopt_array($this->curl, array(
            CURLOPT_URL =>  $this->finalUrl,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST =>  $this->method,
            CURLOPT_POSTFIELDS =>   (string) http_build_query($this->fields),
            CURLOPT_HTTPHEADER =>
            array(
                'Accept: application/json',
                "Authorization: Bearer $this->apiKey",
                'Content-Type: application/x-www-form-urlencoded'

            ),
        ));

        // $this->setOption(CURLOPT_POSTFIELDS, (string) http_build_query($this->fields));
        // MD_dd($this->finalUrl);
        // $this->setOption(CURLOPT_CUSTOMREQUEST, $this->method);
        // $this->setOption(CURLOPT_POST, true);
        // $this->setOption(CURLOPT_HTTP_VERSION, CURL_HTTP_VERSION_1_1);
        // $this->setOption(CURLOPT_URL, 'https://resellha.com/apiv2/domain/domainDetails/araazma.com');
        // curl_setopt_array($this->curl, $this->option);

        $response  = new apiResponse($this->curl);
        $this->response  = $response->result;
        $this->statusCode = $response->getStatusCode();
        $this->apiResponseWithoutParse = $response->apiResponseWithoutParse;
        // log api reqiest detailes just for test
        // logActivity("method : {$this->method} , url : {$this->finalUrl},responseCode:{$this->statusCode} , response : {$response->apiResponseWithoutParse} , params : " . json_encode($this->fields));

        return $this->response;
    }

    function makeUrl($action = null, $url = null, $urlParams = [], $queryParams = [])
    {
        $this->finalUrl = $this->apiUrl . $this->apiPrefix;

        if (!is_null($action) && isset($this->actionUrl[$action])) {
            foreach (explode('/', $this->actionUrl[$action]) as $key => $value) {
                if (substr($value, 0, strlen('{')) === '{')
                    $needed_key[] = substr($value, 1, -1);
            }

            if (!is_null($needed_key)) {
                $diff = array_diff($needed_key, array_keys($urlParams));

                if (!$diff) {
                    throw new Exception(json_encode($diff, JSON_PRETTY_PRINT), 1);
                }

                foreach ($urlParams as $key => $value) {
                    $needed_key[$key] = $value;
                }
            }

            $this->finalUrl .= $this->actionUrl[$action];
        }

        if ($url) {
            $this->finalUrl .= $url;
        }

        $this->finalUrl = is_null($this->sub) ? "https://" . $this->finalUrl : "https://" . $this->sub . "." . $this->finalUrl;

        if (!is_null($queryParams)) {
            $this->finalUrl .= '?' . build_query($queryParams);
        }

        return $this;
    }

    function setOption($key, $value)
    {
        $this->option[$key] = $value;
    }

    function castUrl($url)
    {
        if (substr($url, 0, 7) == 'http://') {
            $url = str_replace("http://", "https://", $url);
        }
        if (substr($url, 0, 4) == 'www.') {
            $url = str_replace("www.", "https://", $url);
        }
        if (substr($url, 0, 8) != 'https://') {
            $url = 'https://' . $url;
        }
        if (strpos($url, '/', -1)) {
            $url = substr($url, 0, -1);
        }
        return $url;
    }
}
