<?php

namespace MDreg\traits;

/**
 * validation domains
 */
trait validation
{
    public $isValid;
    public $message;

    function __construct()
    {
        $this->isValid = false;
        $this->message = '';
    }

    function validateRegister($params)
    {
        if (empty($params["firstname"]) || empty($params["lastname"]) || empty($params["email"])) {
            $this->message = 'your/user\'s profile information is not complete. We need first name, last name, and email.';
            return;
        }

        if (intval($params['regperiod']) > 10 || intval($params['regperiod']) < 1) {
            $this->message = 'register period have to be between 10 and 1.';
            return;
        }

        if (empty($params['ns1']) || empty($params['ns2'])) {
            $this->message = 'Nameserver 1 and Nameserver 2 is required. Please fill these.';
            return;
        }

        for ($nsCount = 1; $nsCount <= 6; $nsCount++) {
            if (!empty($params["ns$nsCount"])  && (substr($params["ns$nsCount"], (-1 * strlen($params["ns$nsCount"]))) == $params['domainname'])) {
                $this->message = "Nameserver fields can't contain domain name. Please fill valid Nameserver.";
                return;
            }
        }

        $this->isValid = true;
        return;
    }

    function validateTransfer($params)
    {
        if (empty($params['eppcode'])) {
            $this->message = 'Epp Code is required for transfer domain.';
            return;
        }

        if (empty($params["firstname"]) || empty($params["lastname"]) || empty($params["email"])) {
            $this->message = "your/user's profile information is not complete. We need first name, last name, and email.";
            return;
        }

        if (intval($params['regperiod']) > 10 || intval($params['regperiod']) < 1) {
            $this->message = 'transfer period have to be between 10 and 1.';
            return;
        }

        $this->isValid = true;
        return;
    }

    function validateRenew($params)
    {
        if (intval($params['term']) < 0 || intval($params['term']) > 10) {
            $this->message = 'period have to been between 0 and 10.';
            return;
        }
        $this->isValid = true;
        return;
    }

    function validateCheckAvailable($params)
    {
        $this->isValid = true;
        return;
    }

    function validateGetNameservers($params)
    {
        $this->isValid = true;
        return;
    }

    function validateGetRegistrarLock($params)
    {
        $this->isValid = true;
        return;
    }

    function validateSaveRegistrarLock($params)
    {
        $this->isValid = true;
        return;
    }

    function validateDomainDetails($params)
    {
        $this->isValid = true;
        return;
    }

    function validateSaveNameservers($params)
    {
        if (empty($params['ns1']) || empty($params['ns2'])) {
            $this->message = 'Nameserver 1 and Nameserver 2 is required. Please fill these.';
            return;
        }
        $this->isValid = true;
        return;
    }

    function validateSaveContactDetails($params)
    {
        $contacts = $params['contactdetails']['contact'];
        foreach ($contacts as $fieldName => $value) {
            if (empty($value)) {
                $this->message = "$fieldName fields is required. Please fill all of the contact form fields.";
                return;
            }
        }

        $this->isValid = true;
        return;
    }

    function validateDNS($params)
    {

        if (!$params['ns1'] && !$params['ns2']) {
            $this->message = 'Nameserver 1 and Nameserver 2 is required. Please fill these.';
            return;
        }
    }

    function validateGetEPPCode($params)
    {
        $this->isValid = true;
        return;
    }

    function validateIDProtectToggle($params)
    {
        $this->isValid = true;
        return;
    }

    function validateRegisterNameserver($params)
    {
        $this->isValid = true;
        return;
    }

    function validateModifyNameserver($params)
    {
        $this->isValid = true;
        return;
    }

    function validateDeleteNameserver($params)
    {
        $this->isValid = true;
        return;
    }
}
