<div>
    {if $domain != null}
        <div class="row" id="saveNSBlock">
            <div class="col-md-12 margin-10 margin-bottom">
                <form class="form-inline saveNameServer" onsubmit="return false;">
                    <input type="hidden" name="id" value="{$domainid}">
                    <input type="hidden" name="domain" value="{$domain}">
                    <div class="form-group ">
                        <label for="nameserver">NS: </label>
                        <div class="input-group">
                            <input type="text" name="nameserver" class="form-control" id="nameserver" placeholder="ns1">
                            <div class="input-group-addon">.{$domain}</div>
                        </div>
                    </div>
                    <div class="form-group ">
                        <label for="ip"> IP: </label>
                        <input type="text" name="ip" class="form-control" id="ip" placeholder="000.000.000.000">
                    </div>
                    <button type="submit" class="btn btn-primary">Save NS</button>
                </form>
            </div>
        </div>
    {/if}

    {if count($nameServers['list']) == 0 && $domain != null}
        <div class="col-md-12 alert alert-warning">
            there is no private nameserver here. press
            <button type="button" id="syncNameServers" class="btn btn-primary"> sync NS</button>
            to sync with your reseller panel.
        </div>
    {else}
        <table class="table table-bordered text-center">
            {$i = 1}
            <tbody>
                <tr>
                    <th class="text-center col">/</th>
                    <th class="text-center col-md-">Name Server</th>
                    <th class="text-center col-md-">IP</th>
                    <th class="text-center col-md-">Actions</th>
                </tr>
                {foreach $nameServers['list'] as $item => $value}
                    <tr>
                        <td class="col">{$i++}</td>
                        <form id="form-{$i}">
                            <input type="hidden" name="id" value="{$domainid}">
                            <input type="hidden" name="domain" value="{$domain}">
                            <input type="hidden" name="ip" value="{$value->ip}">
                            <td class="col-md-">
                                {$value->nameserver}
                                <input type="hidden" name="nameserver" value="{$value->nameserver}">
                            </td>
                            <td class="col-md-">
                                <p id="ip-txt-{$i}">{$value->ip}</p>
                                <input type="text" class="form-control text-center hidden" name="newip" id="ip-input-{$i}"
                                    placeholder="New IP ..." value="{$value->ip}">
                            </td>
                        </form>
                        <td>
                            <button type="button" class="btn btn-success hidden updateNameServer" value="{$i}"
                                id="ip-save-{$i}">
                                <i class="fas fa-check"></i>
                            </button>
                            <button type="button" class="btn btn-warning hidden cancelNameServer" value="{$i}"
                                id="ip-cancel-{$i}">
                                <i class="fas fa-times"></i>
                            </button>
                            <button type="button" class="btn btn-warning editNameServer" id="ip-edit-{$i}" value="{$i}">
                                <i class="far fa-edit"></i>
                            </button>
                            <button type="button" class="btn btn-danger deleteNameServer" id="delete-nameserver-{$i}"
                                value="{$i}">
                                <i class="far fa-trash-alt"></i>
                            </button>
                        </td>
                    </tr>
                {/foreach}
            </tbody>
        </table>
    {/if}
</div>
<script>
    jQuery(document).ready(function() {
        jQuery('.editNameServer').on('click', function() {
            var id = jQuery(this).val();
            jQuery(this).addClass('hidden');
            jQuery('#ip-txt-' + id).addClass('hidden');
            jQuery('#delete-nameserver-' + id).addClass('hidden');
            jQuery('#ip-input-' + id).removeClass('hidden');
            jQuery('#ip-save-' + id).removeClass('hidden');
            jQuery('#ip-cancel-' + id).removeClass('hidden');
        });
        jQuery('.cancelNameServer').on('click', function() {
            var id = jQuery(this).val();
            jQuery(this).addClass('hidden');
            var txt = jQuery('#ip-txt-' + id);
            var input = jQuery('#ip-input-' + id);
            txt.removeClass('hidden');
            jQuery('#delete-nameserver-' + id).removeClass('hidden');
            input.addClass('hidden');
            jQuery('#ip-save-' + id).addClass('hidden');
            jQuery('#ip-edit-' + id).removeClass('hidden');
            input.val(txt.text());
        });
        jQuery('.saveNameServer').on('submit', manageNameServer);
        jQuery('.updateNameServer').on('click', manageNameServer);
        jQuery('.deleteNameServer').on('click', manageNameServer);
        jQuery('#syncNameServers').on('click', manageNameServer);
    });

    function manageNameServer() {
        var data;
        var action;
        if (jQuery(this).attr('id') == 'syncNameServers') {
            data = '';
            action = 'sync';
        } else if (jQuery(this).hasClass('saveNameServer')) {
            data = saveParams(jQuery(this));
            action = 'save';
        } else if (jQuery(this).hasClass('updateNameServer')) {
            data = updateParams(jQuery(this));
            action = 'modify';
        } else {
            data = deleteParams(jQuery(this));
            action = 'delete';
        }
        console.log(data);
        jQuery.ajax({
            url: "clientarea.php?action=domaindetails&id={$domainid}&modop=custom&a=private_nameserver_Manage&subaction=" + action,
            data: data,
            type: 'POST',
            beforeSend: function(xhr) {
                $(".nameserverAlert").button('loading');
            },
            success: function(response) {
                alertManager(response, 'success')
            },
            error: function(response) {
                alertManager(response.responseJSON, 'error');
            },
        });
    }

    function alertManager(payload, type) {
        $('.nameserverAlert').remove();
         var data = payload;
        var message;

        if (type == 'success') {
            message = '<div class="alert alert-success nameserverAlert">' + data.msg + '</div>';
            $(message).insertBefore("#saveNSBlock");
            $('#syncNameServers').parent().remove();
            $(data.data).insertAfter("#saveNSBlock");
            return;
        }
        message = '<div class="alert alert-danger nameserverAlert">' + data.msg + '</div>';
        $(message).insertBefore("#saveNSBlock");

    }

    function saveParams(e) {
        var data = [];
        return jQuery('.saveNameServer').serialize();
       
    }

    function updateParams(e) {
         return jQuery('#form-' + e.val()).serialize();

    }

    function deleteParams(e) {
         return jQuery('#form-' + e.val()).serialize();
    }
</script>